//Kiera Summersett
//Search "GameList" for general locations to place game data
//Search by game type for specific game functions.
//Other files needed for complete game setup: game-search.html, jGame-Search.js
const e = require("express");

exports.GamePlayer = class GamePlayer{
    constructor(){
        this.gamePlay = {};//Unused for now. May remain unused, in which case this will be removed.
    }
    //Generic
    initialGameMap(gameType){//If Statements that direct the gametype to get the proper initial board
        console.log("initialGameMap Called");
        console.log(gameType);
        //--GameList--
        if(gameType=="RockPaperScissors") return this.handleRPSBoard("0");
        if(gameType=="TicTacToe") return this.handleTTTBoard("0");
        if(gameType=="NimGame") return this.handleNIMBoard("0");
    }

    updateGameHandler(data, playerName, gameData, gameType){//If Statements that direct the gametype to update the proper data.
        console.log("updateGameHandler Called");
        const playerInput = data;
        //--GameList--
        if(gameType=="RockPaperScissors") return this.handleRPSBoard({playerInput, playerName, gameData, gameType});
        if(gameType=="TicTacToe") return this.handleTTTBoard({playerInput, playerName, gameData, gameType});
        if(gameType=="NimGame") return this.handleNIMBoard({playerInput, playerName, gameData, gameType});
    }
        
    //Specifics Data
        //RockPaperScissors
    handleRPSBoard(data){//Handles either sending a new Rock Paper Scissors Board, updating the current one, or sending a Win message.
        if(data=="0"){ //return a blank gameboard for a new game of Rock Paper Scissors.
            const newGameBoard = ("<p>Choose One!</p>"
                +"<button class='RPSrock' onclick='buttonClicked("+'"Rock"'+")'>Rock</button>"
                +"<button class='RPSPaper' onclick='buttonClicked("+'"Paper"'+")'>Paper</button>"
                +"<button class='RPSScissors' onclick='buttonClicked("+'"Scissors"'+")'>Scissors</button>");
            return newGameBoard;
        }else{ //handle the data and update the running game.
            const {aStatus, newData} = this.handleRPSData(data);
            if(aStatus=="OKAY"){
                const gameBoard = ("<p>Choose One!</p>"
                +"<button class='RPSrock' onclick='buttonClicked("+'"Rock"'+")'>Rock</button>"
                +"<button class='RPSPaper' onclick='buttonClicked("+'"Paper"'+")'>Paper</button>"
                +"<button class='RPSScissors' onclick='buttonClicked("+'"Scissors"'+")'>Scissors</button>");
                const updateData = newData;
                return {gameBoard, aStatus, updateData};
            }else{
                const {playerInput, playerName, gameData, gameType} = data;
                const gameBoard = ("<p>'Placeholder Text' Won!</p>"
                +"<a href=http://localhost:6211/game-search.html>Go back to the Game Search?</a>");
                const updateData = gameData;
                return {gameBoard, aStatus, updateData};
            }
        }
    }
    handleRPSData(data){//handles calculating and updating general game data, and updates it with new player inputs.
        const {playerInput, playerName, gameData, gameType} = data;
        const dataNumbers = Object.keys(gameData).length;
        if(dataNumbers==0){
            gameData[playerName] = playerInput;
            const newData = gameData;
            const aStatus = "OKAY";
            return {aStatus, newData};
        } //0->1, Still waiting on other player
        if(dataNumbers==1){//Calculate Win Message
            gameData[playerName] = playerInput;
            console.log(Object.entries(gameData));
            const aStatus = this.calculateRPSWin(gameData);
            const newData = {};
            return {aStatus, newData};
        }
    }
    calculateRPSWin(gameData){//A series of if-statements to calculate the proper message.
        const playerChoices = Object.values(gameData);
        if(playerChoices[0]=="Rock"){
            if(playerChoices[1]=="Rock") return "OKAY"; //Tie
            else if(playerChoices[1]=="Paper") return "P2WIN"; //P1 Lost, P2 Won
            else if(playerChoices[1]=="Scissors") return "P1WIN"; //P1 Won, P2 Lost
        }else if(playerChoices[0]=="Paper"){
            if(playerChoices[1]=="Rock") return "P1WIN"; //P1 Won, P2 Lost
            else if(playerChoices[1]=="Paper") return "OKAY"; //Tie
            else if(playerChoices[1]=="Scissors") return "P2WIN"; //P1 Lost, P2 Won
        }else if(playerChoices[0]=="Scissors"){
            if(playerChoices[1]=="Rock") return "P2WIN"; //P1 Lost, P2 Won
            else if(playerChoices[1]=="Paper") return "P1WIN"; //P1 Won, P2 Lost
            else if(playerChoices[1]=="Scissors") return "OKAY"; //Tie
        }
        return "OKAY"; //The game should never reach this point.
    }

        //TicTacToe
    handleTTTBoard(data){
        if(data=="0"){//returns a blank gameboard for a new game of Tic Tac Toe.
            const newGameBoard = ("<p>Choose a square!</p>"
            +"<button class='TTTR1C1'onclick='buttonClicked("+'"R1C1"'+")'>_</button>"
            +"<button class='TTTR1C2'onclick='buttonClicked("+'"R1C2"'+")'>_</button>"
            +"<button class='TTTR1C3'onclick='buttonClicked("+'"R1C3"'+")'>_</button>"+"<br>"
            +"<button class='TTTR2C1'onclick='buttonClicked("+'"R2C1"'+")'>_</button>"
            +"<button class='TTTR2C2'onclick='buttonClicked("+'"R2C2"'+")'>_</button>"
            +"<button class='TTTR2C3'onclick='buttonClicked("+'"R2C3"'+")'>_</button>"+"<br>"
            +"<button class='TTTR3C1'onclick='buttonClicked("+'"R3C1"'+")'>_</button>"
            +"<button class='TTTR3C2'onclick='buttonClicked("+'"R3C2"'+")'>_</button>"
            +"<button class='TTTR3C3'onclick='buttonClicked("+'"R3C3"'+")'>_</button>"
            +"");
            return newGameBoard;
        }else{ //handle the data and update the running game.
            const {playerInput, playerName, gameData, gameType} = data;
            const {aStatus, newData} = this.handleTTTData(data);
            const updateData = gameData;
            let generatingBoard = "<p>Hey! This Updated!</p>";
            if(newData.R1C1=="_")generatingBoard += "<button class='TTTR1C1'onclick='buttonClicked("+'"R1C1"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR1C1'>"+newData.R1C1+"</button>";//Row 1, Column 1
            if(newData.R1C2=="_")generatingBoard += "<button class='TTTR1C2'onclick='buttonClicked("+'"R1C2"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR1C2'>"+newData.R1C2+"</button>";//Row 1, Column 2
            if(newData.R1C3=="_")generatingBoard += "<button class='TTTR1C3'onclick='buttonClicked("+'"R1C3"'+")'>_</button><br>";
            else generatingBoard += "<button class='TTTR1C3'>"+newData.R1C3+"</button><br>";//Row 1, Column 3
            if(newData.R2C1=="_")generatingBoard += "<button class='TTTR2C1'onclick='buttonClicked("+'"R2C1"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR2C1'>"+newData.R2C1+"</button>";//Row 2, Column 1
            if(newData.R2C2=="_")generatingBoard += "<button class='TTTR2C2'onclick='buttonClicked("+'"R2C2"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR2C2'>"+newData.R2C2+"</button>";//Row 2, Column 2
            if(newData.R2C3=="_")generatingBoard += "<button class='TTTR2C3'onclick='buttonClicked("+'"R2C3"'+")'>_</button><br>";
            else generatingBoard += "<button class='TTTR2C3'>"+newData.R2C3+"</button><br>";//Row 2, Column 3
            if(newData.R3C1=="_")generatingBoard += "<button class='TTTR3C1'onclick='buttonClicked("+'"R3C1"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR3C1'>"+newData.R3C1+"</button>";//Row 3, Column 1
            if(newData.R3C2=="_")generatingBoard += "<button class='TTTR3C2'onclick='buttonClicked("+'"R3C2"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR3C2'>"+newData.R3C2+"</button>";//Row 3, Column 2
            if(newData.R3C3=="_")generatingBoard += "<button class='TTTR3C3'onclick='buttonClicked("+'"R3C3"'+")'>_</button>";
            else generatingBoard += "<button class='TTTR3C3'>"+newData.R3C3+"</button>";//Row 3, Column 3
            const gameBoard = generatingBoard;
            return {gameBoard, aStatus, updateData};
        }
    }
    handleTTTData(data){//Mostly a series of if statements to calculate the data holding the current game statistics.
        const {playerInput, playerName, gameData, gameType} = data;
        let isHost = "_";
        //Used https://attacomsian.com/blog/check-if-javascript-object-is-empty to check for empty objects
        if(Object.keys(gameData).length===0) {//Has a fairly long assignment, since gameData is a const variable.
            gameData.playerHostX=playerName;//This ensures the game knows which player is X or O.
            gameData.playerJoinO="_";
            gameData.R1C1="_";
            gameData.R1C2="_";
            gameData.R1C3="_";
            gameData.R2C1="_";
            gameData.R2C2="_";
            gameData.R2C3="_";
            gameData.R3C1="_";
            gameData.R3C2="_";
            gameData.R3C3="_";
        }else if(gameData.playerHostX!=playerName&&gameData.playerJoinO!=playerName) gameData.playerJoinO = playerName;
        if(playerName==gameData.playerHostX) isHost="X";
        else isHost="O";
        if(playerInput=="R1C1")gameData.R1C1 = isHost;
        else if(playerInput=="R1C2")gameData.R1C2 = isHost;
        else if(playerInput=="R1C3")gameData.R1C3 = isHost;
        else if(playerInput=="R2C1")gameData.R2C1 = isHost;
        else if(playerInput=="R2C2")gameData.R2C2 = isHost;
        else if(playerInput=="R2C3")gameData.R2C3 = isHost;
        else if(playerInput=="R3C1")gameData.R3C1 = isHost;
        else if(playerInput=="R3C2")gameData.R3C2 = isHost;
        else if(playerInput=="R3C3")gameData.R3C3 = isHost;
        const aStatus = this.calculateTTTWin(gameData);
        const newData = gameData;
        return {aStatus, newData};
    }
    calculateTTTWin(gameData){//A series of if-statements to calculate the proper message.
        //checks for various "WIN States"
        if(gameData.R1C1=="X"){//Win states requiring the top-left space to be filled
            if(gameData.R2C2=="X"&&gameData.R3C3=="X")return "P1WIN";//Diagonal, Top-Left to Bottom-Right
            if(gameData.R2C1=="X"&&gameData.R3C1=="X")return "P1WIN";//Vertical, Left column
            if(gameData.R1C2=="X"&&gameData.R1C3=="X")return "P1WIN";//Horizontal, Top row
        }
        if(gameData.R1C1=="O"){
            if(gameData.R2C2=="O"&&gameData.R3C3=="O")return "P2WIN";//Diagonal, Top-Left to Bottom-Right
            if(gameData.R2C1=="O"&&gameData.R3C1=="O")return "P2WIN";//Vertical, Left column
            if(gameData.R1C2=="O"&&gameData.R1C3=="O")return "P2WIN";//Horizontal, Top row
        }
        if(gameData.R1C3=="X"){//Win States requiring the top-right space to be filled, not including already-checked spaces.
            if(gameData.R2C2=="X"&&gameData.R3C1=="X")return "P1WIN";//Diagonal, Top-Right to Bottom-Left
            if(gameData.R2C3=="X"&&gameData.R3C3=="X")return "P1WIN";//Vertical, Right column
        }
        if(gameData.R1C3=="O"){
            if(gameData.R2C2=="O"&&gameData.R3C1=="O")return "P2WIN";//Diagonal, Top-Right to Bottom-Left
            if(gameData.R2C3=="O"&&gameData.R3C3=="O")return "P2WIN";//Vertical, Right column
        }
        if(gameData.R1C2=="X"&&gameData.R2C2=="X"&&gameData.R3C2=="X") return "P1WIN";//Vertical, Middle column
        if(gameData.R1C2=="O"&&gameData.R2C2=="O"&&gameData.R3C2=="O") return "P2WIN";//Vertical, Middle column
        if(gameData.R2C1=="X"&&gameData.R2C2=="X"&&gameData.R2C3=="X") return "P1WIN";//Horizontal, Middle row
        if(gameData.R2C1=="O"&&gameData.R2C2=="O"&&gameData.R2C3=="O") return "P2WIN";//Horizontal, Middle row
        if(gameData.R3C1=="X"&&gameData.R3C2=="X"&&gameData.R3C3=="X") return "P1WIN";//Horizontal, Bottom row
        if(gameData.R3C1=="O"&&gameData.R3C2=="O"&&gameData.R3C3=="O") return "P2WIN";//Horizontal, Bottom row
        //Check if Tie
        if(gameData.R1C1!="_"&&gameData.R1C2!="_"&&gameData.R1C3!="_"){//checks row by row if all spaces are used
            if(gameData.R2C1!="_"&&gameData.R2C2!="_"&&gameData.R2C3!="_"){
                if(gameData.R3C1!="_"&&gameData.R3C2!="_"&&gameData.R3C3!="_")return "TIE";//If no spaces are left, the game Ties.
            }
        }
        return "OKAY";
    }

        //NimGame
    handleNIMBoard(data){
            if(data=="0"){//returns a blank gameboard for a new game of Nim
                const newGameBoard = ("<p>Choose the number of \"Matchsticks\" you want to take, and then select the row you're taking them from.</p><br>"
                    +"<p>The player who grabs the last matchstick wins!</p>"
                    +"<p>(If you select a number higher than the number of matchsticks in the row, you take all the matchsticks in that row.)</p>"
                    +"<input type='number' id='sticktaker' name='Sticks To Take:' value='1' min='1' max='7'><br>"
                    +"   | <button class='NIMR1' onclick=buttonClicked({"+'nimRow:"NIMR1",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 1</button><br>"
                    +"  ||| <button class='NIMR2' onclick=buttonClicked({"+'nimRow:"NIMR2",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 2</button><br>"
                    +" ||||| <button class='NIMR3' onclick=buttonClicked({"+'nimRow:"NIMR3",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 3</button><br>"
                    +"||||||| <button class='NIMR4' onclick=buttonClicked({"+'nimRow:"NIMR4",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 4</button><br>"
                );
                return newGameBoard;
            }else{//Generates the updated Nim gameboard and returns it.
                const {playerInput, playerName, gameData, gameType} = data;
                const {aStatus, newData} = this.handleNIMData(data);
                const updateData = gameData;
                let generatingBoard = ("<p>Choose the number of \"Matchsticks\" you want to take, and then select the row you're taking them from.</p><br>"
                +"<p>The player who grabs the last matchstick wins!</p>"
                +"<p>(If you select a number higher than the number of matchsticks in the row, you take all the matchsticks in that row.)</p>"
                +"<input type='number' id='sticktaker' name='Sticks To Take:' value='1' min='1' max='7'><br>"
                );
                if(gameData.R1!=0&&gameData.R1!="0"){
                    for(let i = 0; i < gameData.R1; i++){
                        generatingBoard += "|";
                    }
                    generatingBoard += " <button class='NIMR1' onclick=buttonClicked({"+'nimRow:"NIMR1",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 1</button><br>";
                }
                if(gameData.R2!=0&&gameData.R2!="0"){
                    for(let i = 0; i < gameData.R2; i++){
                        generatingBoard += "|";
                    }
                    generatingBoard += " <button class='NIMR2' onclick=buttonClicked({"+'nimRow:"NIMR2",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 2</button><br>";
                }
                if(gameData.R3!=0&&gameData.R3!="0"){
                    for(let i = 0; i < gameData.R3; i++){
                        generatingBoard += "|";
                    }
                    generatingBoard += " <button class='NIMR3' onclick=buttonClicked({"+'nimRow:"NIMR3",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 3</button><br>"
                }
                if(gameData.R4!=0&&gameData.R4!="0"){
                    for(let i = 0; i < gameData.R4; i++){
                        generatingBoard += "|";
                    }
                    generatingBoard += " <button class='NIMR4' onclick=buttonClicked({"+'nimRow:"NIMR4",'+'takeNum:$('+'"#sticktaker"'+").val()})>Take from Row 4</button><br>"
                }
                const gameBoard = generatingBoard;
                return {gameBoard, aStatus, updateData};
            }
    }
    handleNIMData(data){//Utilizes math to remove the specified number of matchsticks from the data, and handles taking more than what is there.
        const {playerInput, playerName, gameData, gameType} = data;
        const {nimRow, takeNum} = playerInput;
        let isHost = "_";
        if(Object.keys(gameData).length===0) {//Has a fairly long assignment, since gameData is a const variable.
            gameData.playerHost=playerName;
            gameData.playerJoin="_";
            gameData.R1=1;
            gameData.R2=3;
            gameData.R3=5;
            gameData.R4=7;
            gameData.total=16;
        }else if(gameData.playerHost!=playerName&&gameData.playerJoin!=playerName) gameData.playerJoin = playerName;
        console.log(nimRow);
        if(nimRow=="NIMR1"){
            if(takeNum>=gameData.R1){
                let newTotal = gameData.total - gameData.R1;
                gameData.total = newTotal;
                gameData.R1=0;
            }else{
                let newNumber = gameData.R1 - takeNum;
                gameData.R1 = newNumber;
                let newTotal = gameData.total - takeNum;
                gameData.total = newTotal;
            }
        }else if(nimRow=="NIMR2"){
            if(takeNum>=gameData.R2){
                let newTotal = gameData.total - gameData.R2;
                gameData.total = newTotal;
                gameData.R2=0;
            }else{
                let newNumber = gameData.R2 - takeNum;
                gameData.R2 = newNumber;
                let newTotal = gameData.total - takeNum;
                gameData.total = newTotal;
            }
        }else if(nimRow=="NIMR3"){
            if(takeNum>=gameData.R3){
                let newTotal = gameData.total - gameData.R3;
                gameData.total = newTotal;
                gameData.R3=0;
            }else{
                let newNumber = gameData.R3 - takeNum;
                gameData.R3 = newNumber;
                let newTotal = gameData.total - takeNum;
                gameData.total = newTotal;
            }
        }else if(nimRow=="NIMR4"){
            if(takeNum>=gameData.R4){
                let newTotal = gameData.total - gameData.R4;
                gameData.total = newTotal;
                gameData.R4=0;
            }else{
                let newNumber = gameData.R4 - takeNum;
                gameData.R4 = newNumber;
                let newTotal = gameData.total - takeNum;
                gameData.total = newTotal;
            }
        }
        const aStatus = this.calculateNIMWin(gameData, playerName);
        const newData = gameData;
        return {aStatus, newData};
    }
    calculateNIMWin(gameData, playerName){//Checks if the matchsticks are all gone, in which case a player wins.
        if(gameData.total==0||gameData.total=="0"){
            if(playerName==gameData.playerHost) return "P1WIN";
            else if(playerName==gameData.playerJoin) return "P2WIN";
        }else return "OKAY";
    }
}