//token code below from https://stackoverflow.com/questions/36788831/authenticating-socket-io-connections-using-jwt
const {token} = sessionStorage;
const socket = io.connect('http://localhost:6211', { query: {token} });
console.log(sessionStorage);
console.log(token);
socket.emit("initUsername");
socket.on("setUpUsername", function(dataFromServer){
    const yourName = dataFromServer;
    console.log(yourName);
    const newInfo = $("<p class='yourUserName'>Welcome, <a id='userNameHere'>"+yourName+"</a>!</p><a href='change-password.html' class='passchangelink'>Change Password?</a>");
    $(".UserInfo").html(newInfo);
    moveToGame(yourName);
});
socket.on('game-in-wait-for-2P', function(dataFromServer){//Initial startup, game is in waiting
  const [aGameName, aGameToPlay, aPlayerName] = dataFromServer;
  console.log(dataFromServer);
  const gameName = aGameName;
  $("#gameName").html(gameName);
  $("#gameStatus").html("Waiting for second player...");
  const updatedInfo = $("<h3>Host is: <a id='aPlayerName'>"+aPlayerName
  +"</a>.</h3> <h2 id='gameToPlay'>"+aGameToPlay
  +"</h2> <br> <p>If you wish to cancel and go back to the game-search page, click <a href='game-search.html'>here</a>.</p>");
  $("#gameBox").html(updatedInfo);
  //Now in wait for second player.
});
socket.on('game-is-now-in-play', function(dataFromServer){//This is a simple message sent between a joining player found and the game loading.
  $("#gameName").html(dataFromServer);
  $("#gameStatus").html("<h1>Game Starting. Please wait...</h1>");
});
function moveToGame(playerName){//Called to check for if the game is in wait or if the game is in play.
    console.log("Here we are");
    socket.emit("handleHostFinding", playerName);
}
socket.on("gameIsInWait", function(playerName){//Calls for the inital creation of the game in wait setup
  console.log("gameIsInWait Called");
  socket.emit("createHostGame", playerName);
});
socket.on("gameIsInPlay", function(playerName){//Checks if the player is joining or host, and mostly handles setting up the joining player
  console.log("gameIsInPlay Called");
  const playerHost = $("#aPlayerName").text();
  if(playerName!=playerHost) socket.emit("joinHostedGame", playerName);
});
//End of Setup

//Gameplay Functions
socket.on("game-ready", function(dataFromServer){//Inital Game Setup, very similar to game-update and may be merged later.
  const {gameBoard, playerTurn} = dataFromServer;
  const turnText = "<h2>It's currently <a id='playerTurn'>"+playerTurn+"</a>'s turn.</h2>";
  $("#gameBox").html(gameBoard);
  $("#gameStatus").html(turnText);
});
socket.on("game-update", function(dataFromServer){//Updates the game with the updated gameboard and shows the current player's turn.
  const {gameBoard, playerTurn} = dataFromServer;
  const turnText = "<h2>It's currently <a id='playerTurn'>"+playerTurn+"</a>'s turn.</h2>";
  $("#gameBox").html(gameBoard);
  $("#gameStatus").html(turnText);
});
socket.on("game-done", function(dataFromServer){
  const gameBoard = dataFromServer;
  const turnText = "<h2>The game is over!</h2>";
  $("#gameBox").html(gameBoard);
  $("#gameStatus").html(turnText);
});
function buttonClicked(data){//It checks if the player who's turn it is clicked, and sends the button input to the server to update the game.
  console.log("Button Clicked Called");
  const playerName = $("#userNameHere").text();
  const playerCheck = $("#playerTurn").text();
  const gameKey = $("#gameName").text();
  console.log(playerName+" "+playerCheck+" "+gameKey+" "+data);
  console.log(Object.values(data));
  if(playerName==playerCheck) socket.emit("play-game", {data, playerName, gameKey});
}