//Some of the code I use is from https://www.youtube.com/watch?v=b91XgdyX-SM.
//Token code below is from https://stackoverflow.com/questions/36788831/authenticating-socket-io-connections-using-jwt
//Search "GameListHere" to see where game information should be placed
const {token} = sessionStorage;
const socket = io.connect('http://localhost:6211', {
  query: {token}
});
console.log(sessionStorage);
console.log(token);
socket.emit("initUsername");
socket.on("setUpUsername", function(dataFromServer){
    const yourName = dataFromServer;
    console.log(yourName);
    const newInfo = $("<p class='yourUserName'>Welcome, <a id='userNameHere'>"+yourName+"</a>!</p><a href='change-password.html' class='passchangelink'>Change Password?</a>");
    $(".UserInfo").html(newInfo);
    $(".youShouldSignIn").html("Hello!");
    socket.emit("getGamesForSearchList");
});
//end
//Client Data
const playerUserName = "";
const form = document.getElementById('create-game-form');
form.addEventListener('submit', makeNewGame);

//HOST GAME CODE
async function makeNewGame(event){//handles initial game creation
  event.preventDefault(); //prevents page from reloading.
  const gameName = document.getElementById('gameName').value;
  const gameToPlay = getGame();
  console.log(gameName);
  console.log(gameToPlay);
  const playerName = $("#userNameHere").text();
  const result = await fetch('/api/make-new-game', {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify({
      gameName,
      gameToPlay,
      playerName
    })
  }).then((res) => res.json());
  if(result.status === 'ok') {
    console.log('OK');
    alert('Success!');
    socket.emit("getNewGameSearchList");
    window.location.href = "http://localhost:6211/game-page.html";
  } else{
    alert(result.data);
  }
}

socket.on("updatingGameSearchList", function(dataFromServer){//Calls the updateGameList to update the list of games in wait.
  const {gameNames, gameValues} = dataFromServer;
  updateGameList(gameNames, gameValues);
});
function getGame(){//==GameListHere==
  const radGame1 = document.getElementById('GameRPS');
  if(radGame1.checked) return "RockPaperScissors";
  const radGame2 = document.getElementById('GameTTT');
  if(radGame2.checked) return "TicTacToe";
  const radGame3 = document.getElementById('GameNIM');
  if(radGame3.checked) return "NimGame";
}
function updateGameList(gameNames, gameValues){//Updates the list with the current running games.
  $("#join-game-list").html("");
  for(i in gameNames){
    let currGN = gameNames[i];
    let onClickFun = "onclick='joinGame("+'"'+currGN+'"'+")'";
    $("#join-game-list")
    .html($("#join-game-list").html()
    +"<a class='games-available'><button class='game-name' id='g_"+currGN+"' "+onClickFun+">"+currGN
    +"</button><br><a class='game-info'>"
    + "Game: "+gameValues[i].gameToPlay
    +" | Host Name: "+gameValues[i].playerName+"</a><br><br>");
  }
}

//JOIN GAME CODE
function joinGame(gameKey){//sends message to server that the player wants to join a game.
  console.log("Game Clicked: "+gameKey);
  const joinPlayerName = $("#userNameHere").text();
  socket.emit("join-new-game", {gameKey, joinPlayerName});
}

socket.on("joinGameResult", function(dataFromServer){//message from server giving the OK to join a game
  if(dataFromServer=="OK"){
    socket.emit("getNewGameSearchList");
    alert('Success!');
    window.location.href = "http://localhost:6211/game-page.html";//Moves to game upon recieving the server OK
  }else{
    alert('That game no longer exists.');//Here in the case of an error.
    socket.emit("getNewGameSearchList");
  }
});